<?php

add_action( 'wp_ajax_dswr_rm_word', 'dswr_rm_word' );

function dswr_rm_word(){
	global $wpdb;
	$table_words = dswr_get_words_table();
	$word_id = ( isset($_POST["word_id"]) && $_POST["word_id"] > 0 ) ? $_POST["word_id"] : 0;

	if( $word_id > 0 ){
		$count = $wpdb->delete($table_words,
			array(
				'id' => $word_id
			)
		);
		if( $count == 1 ){
			echo 1;
		}else{
			echo 0;
		}
	}else{
		echo 0;
	}

	die();
}

add_action( 'wp_ajax_dswr_rm_list', 'dswr_rm_list' );

function dswr_rm_list(){
	global $wpdb;
	$table_list = dswr_get_lists_table();
	$table_words = dswr_get_words_table();
	$list_id = ( isset($_POST["list_id"]) && $_POST["list_id"] > 0 ) ? $_POST["list_id"] : 0;

	if( $list_id > 0 ){
		$count = $wpdb->delete($table_list,
			array(
				'id' => $list_id
			)
		);
		if( $count == 1 ){
			$wpdb->delete($table_words,
				array(
					'list' => $list_id
				)
			);
			echo 1;
		}else{
			echo 0;
		}
	}else{
		echo 0;
	}

	die();
}

add_action( 'wp_ajax_dswr_rename_list', 'dswr_rename_list' );

function dswr_rename_list(){
	global $wpdb;
	$table_list = dswr_get_lists_table();
	$list_id = ( isset($_POST["list_id"]) && $_POST["list_id"] > 0 ) ? $_POST["list_id"] : 0;
	$new_name = ( isset($_POST["new_name"]) && strlen( $_POST["new_name"] ) > 0 ) ? stripcslashes( $_POST["new_name"] ) : '';

	if( $list_id > 0 && $new_name != '' ){
		$count = $wpdb->update($table_list,
			array(
				'name' => $new_name
			),
			array(
				'id' => $list_id
			)
		);
		if( $count == 1 ){
			echo 1;
		}else{
			echo 0;
		}
	}else{
		echo 0;
	}

	die();
}


add_action( 'wp_ajax_dswr_list_visible', 'dswr_list_visible' );

function dswr_list_visible(){
	global $wpdb;
	$table_list = dswr_get_lists_table();
	$list_id = ( isset($_POST["list_id"]) && $_POST["list_id"] > 0 ) ? $_POST["list_id"] : 0;
	$new_visible = ( isset($_POST["visible"]) && $_POST["visible"] == 1 ) ? 0 : 1;

	if( $list_id > 0 && ( $new_visible == 1 || $new_visible == 0 ) ){
		$count = $wpdb->update($table_list,
			array(
				'visible' => $new_visible
			),
			array(
				'id' => $list_id
			)
		);
		if( $count == 1 ){
			echo 1;
		}else{
			echo 0;
		}
	}else{
		echo 0;
	}

	die();
}
?>