<?php

function dswr_page_url( $list = 0 ){
	$list_url = ( $list > 0 ) ? '&list=' . $list : '';
	return admin_url( 'options-general.php?page=dswr-settings' . $list_url );
}

function dswr_get_post_list( $post_id ){
	return get_post_meta( $post_id, "dswr_list_id", true );
}

function dswr_add_sett_page(){
	add_submenu_page( 'options-general.php', __( 'Da Stop Words Removal' ), __( 'Da Stop Words Removal' ), 'activate_plugins', 'dswr-settings', 'dswr_settings' );
}

add_action('admin_menu', 'dswr_add_sett_page');

function dswr_settings(){
	global $wpdb;
	?>
	<div class="wrap">
		<div id="icon-plugins" class="icon32"></div><h2><?php echo __( 'Da Stop Words Removal' ); ?></h2>

		<br>
		<?php
		if( isset($_GET["list"]) && $_GET["list"] > 0 ){

			// TABLE IS SELECTED

			$list_id = $_GET["list"];

			if( dswr_list_exists( $list_id ) ){

				// IF NEW ONE IS ADDED

				$dswr_new_added = false;
				if( isset($_POST["dswr_add_word"]) &&
					$_POST["dswr_add_word"] == 1 &&
					isset($_POST["dswr_word"]) &&
					isset($_POST["dswr_code"]) ){

					$dswr_new_words = stripcslashes( $_POST["dswr_word"] );

					$dswr_count = add_multiple_words( $dswr_new_words, $list_id );
					$dswr_new_added = true;
				}

				// PREPARE FORM FOR ADDING NEW WORD

				$dswr_code = md5( time() );
				$_SESSION["dswr_code"] = $dswr_code;
				?>

				<?php if( $dswr_new_added ){ ?>
					<?php if( $dswr_count == 1 ){ ?>
						<div id="message" class="updated"><p>New word "<?php echo $_POST["dswr_word"]; ?>" added to this list.</p></div>
					<?php }else{ ?>
						<div id="message" class="updated"><p><?php echo $dswr_count; ?> New words added to this list.</p></div>
					<?php } ?>
				<?php } ?>

				<h3>Add new word</h3>
				<?php dswr_box_start(); ?>
					<form action="<?php echo dswr_page_url( $list_id ); ?>" method="post">
						<input type="hidden" name="dswr_add_word" value="1">
						<input type="hidden" name="dswr_code" value="<?php echo $dswr_code; ?>">
						<input type="text" name="dswr_word">
						<input type="submit" class="button">
					</form>
					<p>You can add multiple comma separated words.</p>
				<?php dswr_box_end(); ?>
				<?php

				$dswr_words = dswr_words_from_list( $list_id );

				?>
				
				<h3>Words from list : <?php echo dswr_list_name( $list_id ); ?></h3>

				<?php if(count($dswr_words)>1){ ?>
					<?php dswr_box_start(); ?>
					<input type="text" class="dswr-search-word" placeholder="Search">
					<a href="#" class="dswr-search-submit button">Search</a>
					<?php dswr_box_end(); ?>
				<?php } ?>

				<ul id="dswr-words">
					<?php foreach( $dswr_words as $word ) : ?>
					<li><span><?php echo $word->word; ?></span><a href="#" data-id="<?php echo $word->id; ?>" title="remove" class="dswr-rm-word">x</a></li>
					<?php endforeach; ?>
				</ul>
				
				<?php
			}else{
				echo "<p>This list doesn't exists of has been removed.";
			}
		}else{

			// LIST OF TABLES
			$dswr_new_added = false;
			if( isset($_POST["dswr_add_list"]) &&
				$_POST["dswr_add_list"] == 1 &&
				isset($_POST["dswr_list_name"]) &&
				isset($_POST["dswr_code"]) ){

				$new_list_name = sanitize_text_field( $_POST["dswr_list_name"] );

				dswr_add_new_list( $new_list_name );
				$dswr_new_added = true;


			}

			$dswr_lists = dswr_all_lists();
			$date_format = get_option( 'date_format' );

			$dswr_code = md5( time() );
			$_SESSION["dswr_code"] = $dswr_code;
			?>

			<?php if( $dswr_new_added ){ ?>
			<div id="message" class="updated"><p>New list "<?php echo $_POST["dswr_list_name"]; ?>" added.</p></div>
			<?php } ?>

			<h3>Add new list</h3>
			<?php dswr_box_start(); ?>
				<form action="<?php echo dswr_page_url(); ?>" method="post">
					<input type="hidden" name="dswr_add_list" value="1">
					<input type="hidden" name="dswr_code" value="<?php echo $dswr_code; ?>">
					<input type="text" name="dswr_list_name">
					<input type="submit" class="button">
				</form>
			<?php dswr_box_end(); ?>

			<h3>Lists</h3>
			<table class="widefat">
				<thead>
					<tr>
						<th>ID</th>
						<th>Name</th>
						<th>Visible</th>
						<th>Created</th>
						<th>Rename</th>
						<th>Delete</th>
					</tr>
				</thead>
				<tbody>
					<?php foreach( $dswr_lists as $list ) : ?>
						<tr data-id="<?php echo $list->id; ?>">
							<td><?php echo $list->id; ?></td>
							<td><a href="<?php echo dswr_page_url( $list->id ); ?>" class="dswr-list-name"><?php echo $list->name; ?></a></td>
							<td><input type="checkbox" class="dswr-list-visible" data-id="<?php if($list->visible == 0){echo '0';}else{echo '1';} ?>" <?php if($list->visible != 0){echo 'checked';} ?> ></td>
							<td><?php echo date( $date_format, strtotime( $list->created ) ); ?></td>
							<td><a href="#" data-id="<?php echo $list->id; ?>" class="dswr-list-rename">Rename</a></td>
							<td><a href="#" data-id="<?php echo $list->id; ?>" class="dswr-list-delete">Delete</a></td>
						</tr>
					<?php endforeach; ?>
			</table>
			<?php
		}
		?>
		<br>
		<?php dswr_donation_html(); ?>
	</div>
	<?php
}

function dswr_box_start(){
	echo '<div class="dswr-data-box">';
}

function dswr_box_end(){
	echo '</div>';
}

function dswr_donation_html(){
	?>
	<div style="clear: both;"></div>
	<br><br>
	<?php dswr_box_start(); ?>
		<div>
			<img src="<?php echo DSWR_PLUGIN_URL; ?>img/LogoIWB-100px.png" class="dswr-iwb-logo">
			<div class="dswr-faire-un-don">
				<form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_top" style="display: inline;" >
					<input type="hidden" name="cmd" value="_s-xclick">
					<input type="hidden" name="hosted_button_id" value="WD7LZZAFH3VRJ">
					<input type="image" src="https://www.paypalobjects.com/fr_FR/FR/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - la solution de paiement en ligne la plus simple et la plus sécurisée !">
					<img alt="" border="0" src="https://www.paypalobjects.com/fr_FR/i/scr/pixel.gif" width="1" height="1">
				</form>
				<p><a href="http://agence.insidedaweb.com" terget="_blank" class="dswr-faire-un-don-link">Plugin done by Inside Da Web, your WordPress Agency</a></p>
			</div>
			<div style="clear: both;"></div>
		</div>
	<?php 
	dswr_box_end();
}

function dswr_list_exists( $id ){
	global $wpdb;
	$table_lists = dswr_get_lists_table();
	$sql = "SELECT COUNT(id) FROM $table_lists WHERE id = $id";
	$count = $wpdb->get_var( $sql );
	if( $count == 1 ){
		return true;
	}else{
		return false;
	}
}

function dswr_list_name( $id ){
	global $wpdb;
	$table_lists = dswr_get_lists_table();
	$sql = "SELECT name FROM $table_lists WHERE id = $id";
	return $wpdb->get_var( $sql );
}

function dswr_add_new_list( $list_name ){
	global $wpdb;
	$created = date('Y-m-d H:i:s');
	$table_lists = dswr_get_lists_table();

	$wpdb->insert( $table_lists,
		array(
			'name' => $list_name,
			'created' => $created
		)
	);

	return $wpdb->insert_id;
}

function dswr_all_lists(){
	global $wpdb;
	$table_lists = dswr_get_lists_table();
	$sql = "SELECT * FROM $table_lists";
	return $dswr_lists = $wpdb->get_results( $sql );
}

function dswr_words_from_list( $list_id ){
	global $wpdb;
	$table_words = dswr_get_words_table();
	$sql = "SELECT * FROM $table_words where list = $list_id";
	return $wpdb->get_results( $sql );
}

function dswr_just_words_from_list( $list_id ){
	global $wpdb;
	$table_words = dswr_get_words_table();
	$sql = "SELECT word FROM $table_words where list = $list_id";
	return $wpdb->get_col( $sql );
}

function dswr_add_new_word( $word, $list_id ){
	global $wpdb;
	$table_words = dswr_get_words_table();
	
	$wpdb->insert( $table_words,
		array(
			'word' => $word,
			'list' => $list_id
		)
	);
}

function add_multiple_words( $words, $list_id ){
	$count = 0;
	$words_array = explode( ',', $words );
	foreach ( $words_array as $word ) {
		dswr_add_new_word( trim( $word ), $list_id );
		$count++;
	}
	return $count;
}

/* ******************************************
*
****************************************** */

function dswr_add_meta_box(){
	$post_types = get_post_types( '', 'names' ); 

	foreach ( $post_types as $post_type ) {
		add_meta_box(
            'dswr_meta_box',
            __( 'Da stop words removal lists' ),
            'dswr_meta_box',
            $post_type,
            'side',
            'high'
        );
	}
}

add_action( 'add_meta_boxes', 'dswr_add_meta_box' );

function dswr_meta_box(){
	global $post;
	$dswr_lists = dswr_all_lists();
	$dswr_list_id = dswr_get_post_list( $post->ID );

	if( count($dswr_lists) > 0 ){

		echo '<select name="dswr_list_id">';
		echo '<option value="0">None</option>';
		foreach ( $dswr_lists as $dswr_list ) {
			if( ( $dswr_list->visible == 1 ) || ( $dswr_list->id == $dswr_list_id ) ){
				echo '<option value="' . $dswr_list->id . '" '.( ($dswr_list_id == $dswr_list->id) ? 'selected' : '' ).'>' . $dswr_list->name . '</option>';
			}
		}
		echo '</select>';

	}else{
		echo '<p>You have no lists yet. Add some <a href="' . dswr_page_url() . '">here</a>.';
	}
}

function dswr_save_meta( $post_id ){
	if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
    	return $post_id;

	if ( 'page' == $_POST['post_type'] ) {
    	if ( ! current_user_can( 'edit_page', $post_id ) )
        	return $post_id;
	} else {
		if ( ! current_user_can( 'edit_post', $post_id ) )
			return $post_id;
  	}

  	update_post_meta( $post_id, 'dswr_list_id', $_POST["dswr_list_id"] );
}

add_action( 'save_post', 'dswr_save_meta' );

function dswr_new_slug( $title, $post_ID, $post_status, $post_type, $post_parent ){
	$slug = sanitize_title( $title );
	// return wp_unique_post_slug( $slug, $post_ID, $post_status, $post_type, $post_parent );
	return $slug;
}

function dswr_filter_title( $title, $list_id ){
	if( $list_id > 0 ){
		$title = stripslashes( strtolower($title) );
		$words = dswr_words_from_list( $list_id );
		
		if( is_array( $words ) ){
			foreach ( $words as $word ) {
				$title = preg_replace('/\b'.$word->word.'\b/', '', $title);
			}
		}
	}
	return $title;
}

function dswr_filter_title_old( $title, $list_id ){
	if( $list_id > 0 ){
		$title = strtolower($title);
		$words = dswr_just_words_from_list( $list_id );
		$title_words = dswr_title_to_word_array( $title );
		$new_title = array();
		if( is_array( $words ) && is_array( $title_words ) ){
			foreach ( $title_words as $title_word ) {
				if( !in_array( trim(stripslashes($title_word)), $words) ){
					$new_title[] = $title_word;
				}
			}
		}
	}
	return dswr_word_array_to_title( $new_title );
}

function dswr_title_to_word_array( $title ){
	return explode(' ', $title);
}

function dswr_word_array_to_title( $word_array ){
	$output = "";
	foreach ($word_array as $word) {
		$output .= ( $output == "" ) ? $word : ' ' . $word;
	}
	return $output;
}

function dswr_modify_slug( $data , $postarr ){
	$old_slug = get_post_field( 'post_name', $postarr["ID"] );
	$current_slug = $data["post_name"];
	$old_list = dswr_get_post_list( $postarr["ID"] );
	$current_list = $postarr["dswr_list_id"];

	if( ( $old_list != $current_list ) || ( strlen($old_slug) < 1 ) ) {

		$filtered_title = dswr_filter_title( $data['post_title'], $current_list );
		$data['post_name'] = dswr_new_slug( $filtered_title, $postarr["ID"], $data['post_status'], $data['post_type'], $data['post_parent'] );
	}
	return $data;
}

add_filter( 'wp_insert_post_data' , 'dswr_modify_slug' , '99', 2 );
?>