jQuery(function(){

	jQuery(".dswr-list-delete").click(function(e){
		e.preventDefault();
		if (confirm('Are you sure you want to delete this list and all words in it?')){
			var current = jQuery(this).closest("tr");
			current.css("opacity", '0.5');
			var list_id = jQuery(this).attr("data-id");


			if( list_id > 0 ){
				var data = {
					'action' : 'dswr_rm_list',
					'list_id' : list_id
				}
				jQuery.post(ajaxurl, data, function(response){
					if( response == 1 ){
						current.remove();
					}else{
						current.css("opacity", '1');
					}
				});
			}else{
				current.css("opacity", '1');
			}
		}
	});

	jQuery(".dswr-list-rename").click(function(e){
		e.preventDefault();
		var current = jQuery(this).closest("tr");
		var current_name = current.find(".dswr-list-name").text();
		var new_name = prompt( "Enter new list name", current_name );
		
		current.css("opacity", '0.5');
		var list_id = jQuery(this).attr("data-id");


		if( ( list_id > 0 ) && ( new_name != null ) ){
			var data = {
				'action' : 'dswr_rename_list',
				'list_id' : list_id,
				'new_name' : new_name
			}
			jQuery.post(ajaxurl, data, function(response){
				if( response == 1 ){
					current.find(".dswr-list-name").text(new_name);
					current.css("opacity", '1');
				}else{
					current.css("opacity", '1');
				}
			});
		}else{
			current.css("opacity", '1');
		}
	});

	jQuery(".dswr-list-visible").change(function(e){
		e.preventDefault();
		var current = jQuery(this).closest("tr");
		var checkbox = jQuery(this);
		var visible = checkbox.attr("data-id");
		
		current.css("opacity", '0.5');
		var list_id = current.attr("data-id");


		if( ( list_id > 0 ) && ( visible == 1 || visible == 0 ) ){
			var data = {
				'action' : 'dswr_list_visible',
				'list_id' : list_id,
				'visible' : visible
			}
			jQuery.post(ajaxurl, data, function(response){
				if( response == 1 ){
					if( visible == 1 ){
						checkbox.removeAttr('checked');
						checkbox.attr('data-id', '0');
					}else{
						checkbox.attr('checked', 'checked');
						checkbox.attr('data-id', '1');
					}
					current.css("opacity", '1');
				}else{
					current.css("opacity", '1');
				}
			});
		}else{
			current.css("opacity", '1');
		}
	});

	jQuery(".dswr-rm-word").click(function(e){
		e.preventDefault();
		var current = jQuery(this);
		current.parent().css("opacity", '0.5');
		var word_id = current.attr("data-id");


		if( word_id > 0 ){
			var data = {
				'action' : 'dswr_rm_word',
				'word_id' : word_id
			}
			jQuery.post(ajaxurl, data, function(response){
				if( response == 1 ){
					current.parent().remove();
				}else{
					current.parent().css("opacity", '1');
				}
			});
		}
	});

	jQuery(".dswr-search-submit").click(function(e){
		e.preventDefault();

		jQuery(".dswr-words").css("opacity", 0.5);
		var word = jQuery(".dswr-search-word").val();
		jQuery("#dswr-words li span").each(function(){
			if(jQuery(this).text().indexOf(word) == -1 ){
				jQuery(this).parent().css("display", "none");
			}else{
				jQuery(this).parent().css("display", "block");
			}
		});
		jQuery(".dswr-words").css("opacity", 1);
	});
});